#ifndef EFL_GENERATED_EVAS_3D_TEXTURE_HH
#define EFL_GENERATED_EVAS_3D_TEXTURE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_texture.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <string>

struct evas_3d_texture;

namespace eo_cxx {

struct evas_3d_texture
{
   /// @param color_format Color format of the texture.
   /// @param pixel_format Pixel format of the data.
   /// @param w Width of the data.
   /// @param h Height of the data.
   /// @param data Pointer to the data.
   ///
   void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_) const;


   /// @param file Path to the image file.
   /// @param key Key in the image file.
   ///
   void file_set(::efl::eina::optional< std::string > file_, ::efl::eina::optional< std::string > key_) const;


   /// @param source Source evas object to be used as the texture data.
   ///
   void source_set(::efl::eina::optional< ::evas::object > source_) const;


   Evas_3D_Color_Format color_format_get() const;


   /// @param[out] w Pointer to receive the width of the texture size.
   /// @param[out] h Pointer to receive the height of the texture size.
   ///
   void size_get(int* w_, int* h_) const;


   /// @param s Wrap mode for S-axis.
   /// @param t Wrap mode for T-axis.
   ///
   void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_) const;


   /// @param[out] s Pointer to receive S-axis wrap mode.
   /// @param[out] t Pointer to receive T-axis wrap mode.
   ///
   void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_) const;


   /// @param min Minification filter used when down-scaling.
   /// @param mag Magnification filter used when up-scaling.
   ///
   void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_) const;


   /// @param[out] min Pointer to receive the minification filter.
   /// @param[out] mag Pointer to receive the magnification filter.
   ///
   void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_) const;


   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   bool source_visible_get() const;


   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   void source_visible_set(bool visible_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_TEXTURE_CLASS);
   }

   operator ::evas_3d_texture() const;
   operator ::evas_3d_texture&();
   operator ::evas_3d_texture const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas_3d_texture*() const { return static_cast<::evas_3d_texture*>(static_cast<D const*>(this)->p); }
      operator ::evas_3d_texture const*() const { return static_cast<::evas_3d_texture const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas_3d_texture const*() const { return static_cast<::evas_3d_texture const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct evas_3d_texture
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas_3d_object
{
   evas_3d_texture(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : evas_3d_texture(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_texture(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_texture(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_texture(evas_3d_texture const& other)
      : evas_3d_texture(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_texture() {}

   /// @param color_format Color format of the texture.
   /// @param pixel_format Pixel format of the data.
   /// @param w Width of the data.
   /// @param h Height of the data.
   /// @param data Pointer to the data.
   ///
   void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_) const;


   /// @param file Path to the image file.
   /// @param key Key in the image file.
   ///
   void file_set(::efl::eina::optional< std::string > file_, ::efl::eina::optional< std::string > key_) const;


   /// @param source Source evas object to be used as the texture data.
   ///
   void source_set(::efl::eina::optional< ::evas::object > source_) const;


   Evas_3D_Color_Format color_format_get() const;


   /// @param[out] w Pointer to receive the width of the texture size.
   /// @param[out] h Pointer to receive the height of the texture size.
   ///
   void size_get(int* w_, int* h_) const;


   /// @param s Wrap mode for S-axis.
   /// @param t Wrap mode for T-axis.
   ///
   void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_) const;


   /// @param[out] s Pointer to receive S-axis wrap mode.
   /// @param[out] t Pointer to receive T-axis wrap mode.
   ///
   void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_) const;


   /// @param min Minification filter used when down-scaling.
   /// @param mag Magnification filter used when up-scaling.
   ///
   void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_) const;


   /// @param[out] min Pointer to receive the minification filter.
   /// @param[out] mag Pointer to receive the magnification filter.
   ///
   void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_) const;


   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   bool source_visible_get() const;


   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   void source_visible_set(bool visible_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_TEXTURE_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas_3d_texture::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas_3d_object::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas_3d_texture* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas_3d_texture::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas_3d_object::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas_3d_texture const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_3D_TEXTURE_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas_3d_texture) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas_3d_texture>::value, "");

inline void evas_3d_texture::data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
}


inline void evas_3d_texture::file_set(::efl::eina::optional< std::string > file_, ::efl::eina::optional< std::string > key_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_file_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(key_)));
}


inline void evas_3d_texture::source_set(::efl::eina::optional< ::evas::object > source_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_source_set(::efl::eolian::to_c(source_)));
}


inline Evas_3D_Color_Format evas_3d_texture::color_format_get() const
{
   Evas_3D_Color_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_texture_color_format_get());
   return _tmp_ret;
}


inline void evas_3d_texture::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_size_get(w_, h_));
}


inline void evas_3d_texture::wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_wrap_set(s_, t_));
}


inline void evas_3d_texture::wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_wrap_get(s_, t_));
}


inline void evas_3d_texture::filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_filter_set(min_, mag_));
}


inline void evas_3d_texture::filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_filter_get(min_, mag_));
}


inline bool evas_3d_texture::source_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_texture_source_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void evas_3d_texture::source_visible_set(bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_source_visible_set(::efl::eolian::to_c(visible_)));
}


inline void eo_cxx::evas_3d_texture::data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
}


inline void eo_cxx::evas_3d_texture::file_set(::efl::eina::optional< std::string > file_, ::efl::eina::optional< std::string > key_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_file_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(key_)));
}


inline void eo_cxx::evas_3d_texture::source_set(::efl::eina::optional< ::evas::object > source_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_source_set(::efl::eolian::to_c(source_)));
}


inline Evas_3D_Color_Format eo_cxx::evas_3d_texture::color_format_get() const
{
   Evas_3D_Color_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_texture_color_format_get());
   return _tmp_ret;
}


inline void eo_cxx::evas_3d_texture::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_size_get(w_, h_));
}


inline void eo_cxx::evas_3d_texture::wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_wrap_set(s_, t_));
}


inline void eo_cxx::evas_3d_texture::wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_wrap_get(s_, t_));
}


inline void eo_cxx::evas_3d_texture::filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_filter_set(min_, mag_));
}


inline void eo_cxx::evas_3d_texture::filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_filter_get(min_, mag_));
}


inline bool eo_cxx::evas_3d_texture::source_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_texture_source_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::evas_3d_texture::source_visible_set(bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_texture_source_visible_set(::efl::eolian::to_c(visible_)));
}


inline ::eo_cxx::evas_3d_texture::operator ::evas_3d_texture() const
{
   return *static_cast<::evas_3d_texture const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_texture::operator ::evas_3d_texture&()
{
   return *static_cast<::evas_3d_texture*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_texture::operator ::evas_3d_texture const&() const
{
   return *static_cast<::evas_3d_texture const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_texture_data_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->data_set(color_format_, pixel_format_, w_, h_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_file_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * key_)
{
   try
      {
         static_cast<T*>(self->this_)->file_set(::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(file_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(key_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_source_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * source_)
{
   try
      {
         static_cast<T*>(self->this_)->source_set(::efl::eolian::to_cxx<::efl::eina::optional< ::evas::object >>(source_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Color_Format _evas_3d_texture_color_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Color_Format _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->color_format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_texture_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_wrap_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_)
{
   try
      {
         static_cast<T*>(self->this_)->wrap_set(s_, t_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_wrap_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_)
{
   try
      {
         static_cast<T*>(self->this_)->wrap_get(s_, t_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_filter_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_)
{
   try
      {
         static_cast<T*>(self->this_)->filter_set(min_, mag_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_texture_filter_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_)
{
   try
      {
         static_cast<T*>(self->this_)->filter_get(min_, mag_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_texture_source_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_visible_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_texture_source_visible_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool visible_)
{
   try
      {
         static_cast<T*>(self->this_)->source_visible_set(::efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_texture >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
      }

      virtual void file_set(::efl::eina::optional< std::string > file_, ::efl::eina::optional< std::string > key_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_file_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(key_)));
      }

      virtual void source_set(::efl::eina::optional< ::evas::object > source_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_source_set(::efl::eolian::to_c(source_)));
      }

      virtual Evas_3D_Color_Format color_format_get()
      {
         Evas_3D_Color_Format _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_texture_color_format_get());
            return _tmp_ret;
      }

      virtual void size_get(int* w_, int* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_size_get(w_, h_));
      }

      virtual void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_wrap_set(s_, t_));
      }

      virtual void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_wrap_get(s_, t_));
      }

      virtual void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_filter_set(min_, mag_));
      }

      virtual void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_filter_get(min_, mag_));
      }

      virtual bool source_visible_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_texture_source_visible_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void source_visible_set(bool visible_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_source_visible_set(::efl::eolian::to_c(visible_)));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_texture >
{
   static const int value = 11 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_texture>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_texture_data_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_data_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_texture_file_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_file_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_texture_color_format_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_color_format_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_texture_size_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_size_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_texture_wrap_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_wrap_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_texture_wrap_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_wrap_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_texture_filter_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_filter_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_texture_filter_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_filter_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_visible_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_visible_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_visible_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_visible_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[11]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[11 + operation_description_class_size<::evas_3d_object>::value]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas_3d_texture >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas_3d_texture, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas_3d_texture>)
{
   return (EVAS_3D_TEXTURE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_TEXTURE_HH

